#!/usr/bin/tclsh

# Read global configuration and start a connection to a database
source "/opt/pagen/bin/pagen.config"
source "/opt/pagen/bin/pagen.lib"
source "/opt/pagen/bin/db_lib.tcl"
Pdb_connect

## Do not modify anything below this point if your are only using the program, but if
## you want to improve it, then you`re welcome to do so.



proc Pmailback {Vret_add} {
global Vresult 

 #  generate a new mail returning the result

 set Vmail [ open "|/usr/sbin/sendmail $Vret_add " w ]
 puts $Vmail "From: Pagen Mailer <pagen-mailer>"
 puts $Vmail "To: lmiguel"
 puts $Vmail "Subject: Your email to PaGEN \[unnumbered\]\n\n"
 puts $Vmail " Your email was delivered to pagen-mailer. This is the result:"
 puts $Vmail " ------------------------------------------------------------ "
 puts $Vmail " Content: $Vresult(counter) lines "
 puts $Vmail " $Vresult(content)\n"
 puts $Vmail " Commands:"
 puts $Vmail " $Vresult(commands)"
 puts $Vmail " Errors : "
 if [ string match $Vresult(errors) "" ] {
   puts $Vmail " None found. "
 } else {
   puts $Vmail " $Vresult(errors) "
 }
 puts $Vmail " ------------------------------------------------------------ "        
 puts $Vmail " Output of the Commands:"
 puts $Vmail "$Vresult(command_results)" 
 
 puts $Vmail " ------------------------------------------------------------ "
 if ![ string match $Vresult(content) "  -no content- " ] {
  catch "exec /opt/pagen/bin/content.sh $Vresult(file)" result
  puts $Vmail " Output of the content inserter (Content2):"
  puts $Vmail "$result"
  puts $Vmail " ------------------------------------------------------------ "
  if [ string match "*ERROR:QUIT*" $result ] {
	puts $Vmail "  The page updater (PaGEN) was not launched due to errors on the previous step"
  } else {	
        puts $Vmail " Output of the page updater (PaGEN):"
	catch "exec /opt/pagen/bin/pagen.sh " result
	puts $Vmail "$result"
  } 
 puts $Vmail " ------------------------------------------------------------ "
 }

 close $Vmail
 exec /usr/sbin/sendmail -q

}

proc Pexecute {Vline_command} {
global Vresult

  # Tries to parse and execute the command
  set Vcommand [ string trim [ string range $Vline_command 8 end ]]
  append Vresult(commands) "  Command Found: \[$Vcommand\] "
  switch -regexp -- $Vcommand {
        dump* {
			foreach {command value} [ split $Vcommand ":" ] {}
  			set Vvalue [ string trim $value ]
			append Vresult(commands) "OK - Dumping content number \[$Vvalue\]"
			append Vresult(command_results) "<pagen>\n[Pcontent_dump $Vvalue]\n</pagen>"
		}
	default  { 
			append Vresult(errors) " Execution error: Unknown command\n"
		     	append Vresult(commands) " (?)\n"
		 }
  }  
  
}

proc Pparse_content {Vmail_content}  {
global Vresult

   set Vresult(flag) 0 
   set Vflag ""
   set Vcontent ""
   set Vresult(counter) 0 
   set Vresult(command_results) ""
   set Vresult(commands) ""
   set Vresult(errors) ""
   foreach line [ split $Vmail_content \n ] {
     if [ string match "x-pagen-*" $line ] { Pexecute $line }
     if { [ string match "*</pagen>*" $line ] } {
         if [ string match "open" $Vflag ] {
               	set Vflag close
         } else {
	        append Vresult(errors) " Parse Error    : </pagen> found, but no previous <pagen> mark. Check your syntax\n"
	 }
     }
     if [ string match "open" $Vflag ] { append Vcontent "$line\n" } 
     if [ string match "*<pagen>*" $line ] { set Vflag open }
     incr Vresult(counter) 1
   }

   # if the flag is still open, is an error
   if [ string match "open" $Vflag ] { append Vresult(errors) "  Parse Error   : </pagen> mark was not found.\n" }
   # if content is still "", no content found
   if { [ string match "" $Vcontent  ] || ![ string match $Vresult(errors) "" ]} { 
	append Vresult(errors) "  Parse Error    : No content found\n" 
        set Vresult(content) "  -no content- "
   } else {
        # Content found! lets create a file with it!
 	set Vresult(content) "$Vcontent"
        set Vfile  [ Pmess_id_gen ]
        set Vout [ open $Vfile w ] 
        append Vresult(content) "\n  File saved: $Vfile " 
        set Vresult(file) $Vfile
	puts $Vout $Vcontent
        close $Vout
   } 
   return
}

proc Pmess_id_gen {} {
global Vconf Ctmp_content_dir

 # This procedure generates a unique id for this message
 set Vmess_id "auto-[ clock seconds ]"
 #set Vmess_id "elmismo"
 set Vfile "$Ctmp_content_dir/$Vmess_id.mail"
 set Vcounter 0
 # Ensure the directory exists. 
 Pdir_test $Ctmp_content_dir
 while {[ file exists $Vfile ] > 0 } { 
   # mmm... it exists. Lets add a new number to it.
   set Vfile "$Ctmp_content_dir/$Vcounter-$Vmess_id.mail" 
   #puts "New file name : $Vfile"
   incr Vcounter 1
 }
 return $Vfile
}

proc main {} {
global Vconf
  set Vmail_content [ read stdin ]
  Pparse_content $Vmail_content
  Pmailback lmiguel
}

main


