#!/usr/bin/wish
#############################################################################
# Visual Tcl v1.20 Project
#

#################################
# GLOBAL VARIABLES
#
global Ccontent_dir; 
global Cdatabase; 
global Vdb_handle; 
global Vdb_stats; 
global widget; 

#################################
# USER DEFINED PROCEDURES
#
proc init {argc argv} {
global Cdatabase Ccontent_dir Vdb_stats

set Vdb_stats(execs) "0"
source "pagen.config"
source "db_lib.tcl"
source "pagen.lib"

Pdb_connect
}

init $argc $argv


proc {Pedit_content} {content_title} {
global Acontent

if ![winfo exists .top21] { Window show .top21}

array set Acontent [ Pdb_exec "select id, page, icon, title, author, date, content, last_modified, priority from content where title='$content_title'"]

array set Atmp [ Pdb_exec "select title from pages where name='$Acontent(0,page)'"]
set Acontent(0,parent_title) "$Atmp(0,title)"

.top21.fra24.tex31 delete 0.0 end
.top21.fra24.tex31 insert 0.0 "$Acontent(0,content)"

Window show .top21
}

proc {Pedit_content_by_number} {content_number} {
global Acontent

if ![winfo exists .top21] { Window show .top21}

array set Acontent [ Pdb_exec "select id, page, icon, title, author, date, content, last_modified, priority from content where id='$content_number'"]

array set Atmp [ Pdb_exec "select title from pages where name='$Acontent(0,page)'"]
set Acontent(0,parent_title) "$Atmp(0,title)"

.top21.fra24.tex31 delete 0.0 end
.top21.fra24.tex31 insert 0.0 "$Acontent(0,content)"

Window show .top21
}

proc {Pedit_page} {} {
global Apage


if ![ winfo exists .top41 ] { Window show .top41 }

set Vcur_name "[.top29.fra33.lis35 get [.top29.fra33.lis35 curselection]]"
set Vquery "select id, name,parent, category,title, icon, file, last_modified, render from pages where title='$Vcur_name'"
array set Apage [ Pdb_exec "$Vquery"]


set Vquery "select title from pages where name='$Apage(0,parent)'"
#puts $Vquery
array set Atemp [ Pdb_exec "$Vquery" ]

set Apage(0,parent_title) "$Atemp(0,title)"

array set Acategories [ Pdb_exec "select category from categories" ]
.top41.fra44.men61.01 delete 0 end
for { set i 0 } { $i < $Acategories(0,tups) } { incr i 1 } {
  .top41.fra44.men61.01 add command -label "$Acategories($i,category)" -command "set Apage(0,category) $Acategories($i,category)"
    
}

array set Aparents [ Pdb_exec "select name, title from pages" ] 
.top41.fra44.men60.01 delete 0 end
for { set i 0 } { $i < $Aparents(0,tups) } { incr i 1 } {
  .top41.fra44.men60.01 add command -label "$Aparents($i,name)" -command "set Apage(0,parent) $Aparents($i,name); set Apage(0,parent_title) \"$Aparents($i,title)\""   
}


array set Acontent_list [ Pdb_exec "select title from content where page='$Apage(0,name)'" ]
.top41.fra17.lis18 delete 0 end

for { set i 0 } { $i < $Acontent_list(0,tups) } { incr i 1 } {
  .top41.fra17.lis18 insert end "$Acontent_list($i,title)"   
}

Window show .top41
}

proc {Pfill_page_menu} {} {
array set Apages [ Pdb_exec "select name, title from pages order by title" ]

.top21.fra24.men43.m delete 0 end
for { set i 0 } { $i < $Apages(0,tups) } { incr i 1 } {

  .top21.fra24.men43.m add command -label "$Apages($i,title)" -command "set Acontent(0,page) $Apages($i,name); set Acontent(0,parent_title) \"$Apages($i,title)\"" 

}
}

proc {Pload_actual_pages} {} {
array set Vpages [ Pdb_exec "select title, name from pages order by title" ]
.top29.fra33.lis35 delete 0 end

for { set i 0 } { $i < $Vpages(0,tups) } { incr i 1 } {

    .top29.fra33.lis35 insert end $Vpages($i,title) 
}
}

proc {Pnew_content} {} {
global Acontent

if ![winfo exists .top21] { Window show .top21}

Pfill_page_menu
set Acontent(0,id) "new"
set Acontent(0,title) ""
set Acontent(0,icon) ""
set Acontent(0,author) ""
set Acontent(0,date) "[ clock format [ clock seconds ] -format "%d/%m/%Y %H:%M" ]"
set Acontent(0,priority) "50"
set Acontent(0,content) ""
set Acontent(0,last_modified) "never"

.top21.fra24.tex31 delete 0.0 end

Window show .top21
}

proc {Pnew_page} {} {
global Apage

if ![ winfo exists .top41 ] { Window show .top41 }

set Apage(0,id) "new"
set Apage(0,name) ""
set Apage(0,parent) "please select"
set Apage(0,parent_title) ""
set Apage(0,category) "please select"
set Apage(0,title) ""
set Apage(0,icon) ""
set Apage(0,file) ""

array set Acategories [ Pdb_exec "select category from categories" ]
.top41.fra44.men61.01 delete 0 end
for { set i 0 } { $i < $Acategories(0,tups) } { incr i 1 } {
  .top41.fra44.men61.01 add command -label "$Acategories($i,category)" -command "set Apage(0,category) $Acategories($i,category)"
    
}

array set Aparents [ Pdb_exec "select name, title from pages order by title" ] 
.top41.fra44.men60.01 delete 0 end
for { set i 0 } { $i < $Aparents(0,tups) } { incr i 1 } {
  .top41.fra44.men60.01 add command -label "$Aparents($i,title)" -command "set Apage(0,parent) $Aparents($i,name); set Apage(0,parent_title) \"$Aparents($i,title)\""   
}

.top41.fra17.lis18 delete 0 end

Window show .top41
}

proc Pinsert_debug {Vbuffer} {

.top17.fra20.tex23 insert end "[ gets $Vbuffer ]\n"

if [eof $Vbuffer] {
    close $Vbuffer
 }
}

proc {Prefresh_pagen} {} {
global Vpagen_parameters

set Vpagen_buf [ open "| ./refresh $Vpagen_parameters" w+ ]

.top17.fra20.tex23 delete 0.0 end
fconfigure $Vpagen_buf -buffering line
fileevent $Vpagen_buf readable "Pinsert_debug $Vpagen_buf"


}

proc {Psave_content} {} {
global Ccontent_dir Acontent

set Vfile "$Ccontent_dir/$Acontent(0,page).$Acontent(0,id)"

#if [ file exists $Vfile ] {

#  set Vfile_bk "$Vfile.back"
#  puts "making backup"
#  if [ file exists $Vfile_bk ] {
#      file delete $Vfile_bk
#  }
#  file copy $Vfile $Vfile_bk
#}

set Acontent(0,content) "[ .top21.fra24.tex31 get 0.0 end ]"

set Vfh [ open "$Vfile" w ]

puts $Vfh "x-content: text"
if { $Acontent(0,id) != "new" } {
    puts $Vfh "x-uid: $Acontent(0,id)"
}
puts $Vfh "x-page: $Acontent(0,page)"
puts $Vfh "x-title: $Acontent(0,title)"
puts $Vfh "x-icon: $Acontent(0,icon)"
puts $Vfh "x-author: $Acontent(0,author)"
puts $Vfh "x-date: $Acontent(0,date)"
puts $Vfh "x-priority: $Acontent(0,priority)"
puts $Vfh "x-text: $Acontent(0,content)"
close $Vfh

Window hide .top21
}

proc {Psave_page} {} {
global Apage Ccontent_dir


set Vfile "$Ccontent_dir/page.$Apage(0,name)"
#puts "saving this page ($Vfile)"

set Vfh [ open $Vfile w ]

puts $Vfh "x-content: page"
puts $Vfh "x-name: $Apage(0,name)"
puts $Vfh "x-category: $Apage(0,category)"
puts $Vfh "x-file: $Apage(0,file)"
puts $Vfh "x-icon: $Apage(0,icon)"
puts $Vfh "x-title: $Apage(0,title)"
puts $Vfh "x-parent: $Apage(0,parent)"

close $Vfh

Window hide .top41
}

proc {main} {argc argv} {

}

proc {Pdelete_content} {} {
global Acontent



set Vdetails "($Acontent(0,id)) - $Acontent(0,title)"

if ![tk_dialog .confirm "Confirm" "Are you sure to delete this text chunk?\n$Vdetails" ""  "1" "Yes" "No"] {
 # Delete this chunk
 Pdb_exec "delete from content where id = '$Acontent(0,id)'"
 Pdb_exec "update pages set last_modified = '[Pdate_now]' where name='$Acontent(0,page)'"
 Window hide .top21
}
}

proc {Window} {args} {
global vTcl
    set cmd [lindex $args 0]
    set name [lindex $args 1]
    set newname [lindex $args 2]
    set rest [lrange $args 3 end]
    if {$name == "" || $cmd == ""} {return}
    if {$newname == ""} {
        set newname $name
    }
    set exists [winfo exists $newname]
    switch $cmd {
        show {
            if {$exists == "1" && $name != "."} {wm deiconify $name; return}
            if {[info procs vTclWindow(pre)$name] != ""} {
                eval "vTclWindow(pre)$name $newname $rest"
            }
            if {[info procs vTclWindow$name] != ""} {
                eval "vTclWindow$name $newname $rest"
            }
            if {[info procs vTclWindow(post)$name] != ""} {
                eval "vTclWindow(post)$name $newname $rest"
            }
        }
        hide    { if $exists {wm withdraw $newname; return} }
        iconify { if $exists {wm iconify $newname; return} }
        destroy { if $exists {destroy $newname; return} }
    }
}

#################################
# VTCL GENERATED GUI PROCEDURES
#

proc vTclWindow. {base} {
    if {$base == ""} {
        set base .
    }
    ###################
    # CREATING WIDGETS
    ###################
    wm focusmodel $base passive
    wm geometry $base 1x1+0+0
    wm maxsize $base 2545 930
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm withdraw $base
    wm title $base "vt.tcl"
    ###################
    # SETTING GEOMETRY
    ###################
}

proc vTclWindow.top17 {base} {
    if {$base == ""} {
        set base .top17
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background #12bcca -menu .top17.m19 
    wm focusmodel $base passive
    wm geometry $base 610x414+590+69
    wm maxsize $base 750 500
    wm minsize $base 300 300
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "PaGEN Quick Editor v0.2"
    menu $base.m19 \
        -cursor {} -tearoff 0 
    $base.m19 add cascade \
        -menu .top17.m19.men20 -label File 
    $base.m19 add cascade \
        -menu .top17.m19.men24 -label Edit 
    $base.m19 add cascade \
        -menu .top17.m19.men28 -label Create 
    menu $base.m19.men20 \
        -tearoff 0 
    $base.m19.men20 add command \
        -command exit -label Exit 
    menu $base.m19.men24 \
        -tearoff 0 
    $base.m19.men24 add command \
        -command {Window show .top29
Pload_actual_pages} -label Page 
    $base.m19.men24 add command \
        -label Category 
    $base.m19.men24 add command \
        -command {Window show .top20} -label {Text Chunk} 
    menu $base.m19.men28 \
        -tearoff 0 
    $base.m19.men28 add command \
        -command Pnew_page -label {New Page} 
    $base.m19.men28 add command \
        -label {New Category} 
    $base.m19.men28 add command \
        -command Pnew_content -label {New Text Chunk} 
    frame $base.fra30 \
        -background #8caad8 -borderwidth 2 -height 75 -relief groove \
        -width 125 
    label $base.fra30.01 \
        -background #8caad8 -borderwidth 1 -font {Helvetica -14 bold} \
        -text {PaGEN Quick Editor} 
    frame $base.fra17 \
        -background #8caad8 -borderwidth 2 -height 75 -relief groove \
        -width 125 
    label $base.fra17.lab17 \
        -anchor e -background #8caad8 -borderwidth 1 -font {Helvetica -12} \
        -text {DB Queries Run} 
    entry $base.fra17.ent19 \
        -background #e4e4e8 -selectbackground #8caad8 \
        -textvariable Vdb_stats(execs) 
    frame $base.fra18 \
        -background #8caad8 -borderwidth 2 -height 75 -relief groove \
        -width 125 
    label $base.fra18.lab19 \
        -background #8caad8 -borderwidth 1 -font {Helvetica -10} \
        -text Statistics 
    frame $base.fra20 \
        -background #8caad8 -borderwidth 2 -height 75 -relief groove \
        -width 125 
    scrollbar $base.fra20.scr22 \
        -background grey77 -command {.top17.fra20.tex23 yview} -relief flat 
    text $base.fra20.tex23 \
        -font {Courier -10} -relief groove \
        -yscrollcommand {.top17.fra20.scr22 set} 
    button $base.fra20.but24 \
        -command Prefresh_pagen -font {Helvetica -12} -text {Launch PaGEN} 
    label $base.fra20.parameters \
	-background #8caad8 -borderwidth 1 -font {Helvetica -10} \
        -text "With parameters"
    entry $base.fra20.parameters_entry \
	-background #e4e4e8 -selectbackground #8caad8 \
        -textvariable Vpagen_parameters
    frame $base.fra21 \
        -background #8caad8 -borderwidth 2 -height 75 -relief groove \
        -width 125 
    label $base.fra21.01 \
        -background #8caad8 -borderwidth 1 -font {Helvetica -10} \
        -text {Pagen Console} 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.fra30 \
        -x 5 -y 5 -width 600 -height 30 -anchor nw -bordermode ignore 
    place $base.fra30.01 \
        -x 435 -y 5 -width 161 -height 18 -anchor nw -bordermode ignore 
    place $base.fra17 \
        -x 5 -y 45 -width 600 -height 90 -anchor nw -bordermode ignore 
    place $base.fra17.lab17 \
        -x 345 -y 15 -width 106 -height 18 -anchor nw -bordermode ignore 
    place $base.fra17.ent19 \
        -x 460 -y 10 -width 133 -height 22 -anchor nw -bordermode ignore 
    place $base.fra18 \
        -x 15 -y 35 -width 140 -height 20 -anchor nw -bordermode ignore 
    place $base.fra18.lab19 \
        -x 5 -y 5 -width 47 -height 11 -anchor nw -bordermode ignore 
    place $base.fra20 \
        -x 5 -y 145 -width 600 -height 265 -anchor nw -bordermode ignore 
    place $base.fra20.scr22 \
        -x 570 -y 20 -width 21 -height 207 -anchor nw -bordermode ignore 
    place $base.fra20.tex23 \
        -x 10 -y 15 -width 558 -height 215 -anchor nw -bordermode ignore 
    place $base.fra20.but24 \
        -x 10 -y 235 -width 150 -height 26 -anchor nw -bordermode ignore 
    place $base.fra20.parameters \
	-x 180 -y 235 -width 100 -height 26 -anchor nw -bordermode ignore
    place $base.fra20.parameters_entry \
        -x 290 -y 235 -width 222 -height 26 -anchor nw -bordermode ignore
    place $base.fra21 \
        -x 15 -y 135 -width 140 -height 20 -anchor nw -bordermode ignore 
    place $base.fra21.01 \
        -x 6 -y 2 -width 77 -height 15 -anchor nw -bordermode ignore 
}

proc vTclWindow.top20 {base} {
    if {$base == ""} {
        set base .top20
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background #12bcca 
    wm focusmodel $base passive
    wm geometry $base 284x119+619+153
    wm maxsize $base 2545 930
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm title $base "Select Text Chunk"
    frame $base.fra21 \
        -background #8caad8 -borderwidth 2 -height 75 -relief groove \
        -width 125 
    label $base.fra21.lab22 \
        -background #8caad8 -borderwidth 1 -font {Arial -12} \
        -text {Enter text chunk number} 
    entry $base.fra21.ent23 \
        -textvariable Vchunk_to_edit 
    button $base.fra21.but24 \
        -command {Pedit_content_by_number $Vchunk_to_edit;Window hide .top20} \
        -text Edit 
    button $base.fra21.but25 \
        -command {Window hide .top20} -text Cancel 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.fra21 \
        -x 5 -y 5 -width 275 -height 110 -anchor nw -bordermode ignore 
    place $base.fra21.lab22 \
        -x 5 -y 5 -width 141 -height 28 -anchor nw -bordermode ignore 
    place $base.fra21.ent23 \
        -x 30 -y 35 -width 213 -height 22 -anchor nw -bordermode ignore 
    place $base.fra21.but24 \
        -x 165 -y 70 -width 82 -height 26 -anchor nw -bordermode ignore 
    place $base.fra21.but25 \
        -x 15 -y 70 -width 82 -height 26 -anchor nw -bordermode ignore 
}

proc vTclWindow.top21 {base} {
    if {$base == ""} {
        set base .top21
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background #12bcca -cursor xterm -menu .top21.m17 
    wm focusmodel $base passive
    wm geometry $base 790x552+402+262
    wm maxsize $base 2545 930
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm title $base "Content Editor"
    frame $base.fra22 \
        -background #8caad8 -borderwidth 2 -height 75 -relief groove \
        -width 125 
    label $base.fra22.01 \
        -background #8caad8 -borderwidth 1 -font {Helvetica -12} \
        -text {PaGEN Content Editor} 
    frame $base.fra24 \
        -background #8caad8 -borderwidth 2 -height 75 -relief groove \
        -width 125 
    label $base.fra24.01 \
        -anchor e -background #8caad8 -borderwidth 1 -font {Helvetica -12} \
        -text {Page ID} 
    label $base.fra24.lab25 \
        -anchor e -background #8caad8 -borderwidth 1 -font {Helvetica -12} \
        -text Title 
    label $base.fra24.lab26 \
        -anchor e -background #8caad8 -borderwidth 1 -font {Helvetica -12} \
        -text {Parent Page} 
    label $base.fra24.lab27 \
        -anchor e -background #8caad8 -borderwidth 1 -font {Helvetica -12} \
        -text {Last Modified} 
    label $base.fra24.lab28 \
        -anchor e -background #8caad8 -borderwidth 1 -font {Helvetica -12} \
        -text Author 
    label $base.fra24.lab29 \
        -anchor e -background #8caad8 -borderwidth 1 -font {Helvetica -12} \
        -text {Creation Date} 
    label $base.fra24.lab30 \
        -anchor e -background #8caad8 -borderwidth 1 -font {Helvetica -12} \
        -text Content 
    text $base.fra24.tex31 \
        -font {Helvetica -10} -wrap word \
        -yscrollcommand {.top21.fra24.scr32 set} 
    scrollbar $base.fra24.scr32 \
        -background grey77 -command {.top21.fra24.tex31 yview} 
    button $base.fra24.but34 \
        -command {Window hide .top21} -text {Discard Changes} 
    button $base.fra24.but35 \
        -command Psave_content -text {Save Changes} 
    entry $base.fra24.ent36 \
        -textvariable Acontent(0,id) 
    entry $base.fra24.ent37 \
        -textvariable Acontent(0,title) 
    entry $base.fra24.ent38 \
        -textvariable Acontent(0,author) 
    entry $base.fra24.ent39 \
        -textvariable Acontent(0,date) 
    entry $base.fra24.ent40 \
        -textvariable Acontent(0,last_modified) 
    label $base.fra24.lab41 \
        -anchor e -background #8caad8 -borderwidth 1 -font {Helvetica -12} \
        -text Priority 
    entry $base.fra24.ent42 \
        -textvariable Acontent(0,priority) 
    menubutton $base.fra24.men43 \
        -font {Helvetica -10} -menu .top21.fra24.men43.m -padx 4 -pady 3 \
        -relief raised -text wtc -textvariable Acontent(0,page) 
    menu $base.fra24.men43.m
    entry $base.fra24.ent44 \
        -textvariable Acontent(0,parent_title) 
    entry $base.fra24.ent17 \
        -textvariable Acontent(0,icon) 
    label $base.fra24.lab18 \
        -anchor e -background #8caad8 -borderwidth 1 -font {Helvetica -12} \
        -text {Icon file name} 
    menu $base.m17 \
        -cursor {} -tearoff 0 
    $base.m17 add cascade \
        -menu .top21.m17.men18 -label Action 
    menu $base.m17.men18 \
        -tearoff 0 
    $base.m17.men18 add command \
        -command Pdelete_content -label Delete 
    $base.m17.men18 add command \
        -command {Window hide .top21} -label Discard 
    $base.m17.men18 add command \
        -command Psave_content -label {Save Changes} 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.fra22 \
        -x 5 -y 5 -width 780 -height 30 -anchor nw -bordermode ignore 
    place $base.fra22.01 \
        -x 625 -y 10 -width 151 -height 18 -anchor nw -bordermode ignore 
    place $base.fra24 \
        -x 5 -y 35 -width 780 -height 510 -anchor nw -bordermode ignore 
    place $base.fra24.01 \
        -x 15 -y 15 -width 131 -height 18 -anchor nw -bordermode ignore 
    place $base.fra24.lab25 \
        -x 15 -y 40 -width 131 -height 18 -anchor nw -bordermode ignore 
    place $base.fra24.lab26 \
        -x 15 -y 65 -width 131 -height 18 -anchor nw -bordermode ignore 
    place $base.fra24.lab27 \
        -x 320 -y 15 -width 131 -height 18 -anchor nw -bordermode ignore 
    place $base.fra24.lab28 \
        -x 15 -y 95 -width 131 -height 18 -anchor nw -bordermode ignore 
    place $base.fra24.lab29 \
        -x 15 -y 120 -width 131 -height 18 -anchor nw -bordermode ignore 
    place $base.fra24.lab30 \
        -x 10 -y 165 -width 46 -height 18 -anchor nw -bordermode ignore 
    place $base.fra24.tex31 \
        -x 10 -y 185 -width 743 -height 285 -anchor nw -bordermode ignore 
    place $base.fra24.scr32 \
        -x 755 -y 185 -width 16 -height 282 -anchor nw -bordermode ignore 
    place $base.fra24.but34 \
        -x 5 -y 475 -anchor nw -bordermode ignore 
    place $base.fra24.but35 \
        -x 645 -y 475 -width 123 -height 26 -anchor nw -bordermode ignore 
    place $base.fra24.ent36 \
        -x 155 -y 10 -width 133 -height 22 -anchor nw -bordermode ignore 
    place $base.fra24.ent37 \
        -x 155 -y 35 -width 443 -height 22 -anchor nw -bordermode ignore 
    place $base.fra24.ent38 \
        -x 155 -y 90 -width 443 -height 22 -anchor nw -bordermode ignore 
    place $base.fra24.ent39 \
        -x 155 -y 115 -width 133 -height 22 -anchor nw -bordermode ignore 
    place $base.fra24.ent40 \
        -x 460 -y 10 -width 138 -height 22 -anchor nw -bordermode ignore 
    place $base.fra24.lab41 \
        -x 320 -y 120 -width 131 -height 18 -anchor nw -bordermode ignore 
    place $base.fra24.ent42 \
        -x 460 -y 115 -width 138 -height 22 -anchor nw -bordermode ignore 
    place $base.fra24.men43 \
        -x 155 -y 60 -width 134 -height 24 -anchor nw -bordermode ignore 
    place $base.fra24.ent44 \
        -x 300 -y 60 -width 298 -height 22 -anchor nw -bordermode ignore 
    place $base.fra24.ent17 \
        -x 155 -y 140 -width 133 -height 22 -anchor nw -bordermode ignore 
    place $base.fra24.lab18 \
        -x 15 -y 145 -width 131 -height 18 -anchor nw -bordermode ignore 
}

proc vTclWindow.top29 {base} {
    if {$base == ""} {
        set base .top29
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background #12bcca -menu .top29.m37 
    wm focusmodel $base passive
    wm geometry $base 455x229+774+564
    wm maxsize $base 2545 930
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Page Selector"
    frame $base.fra31 \
        -background #8caad8 -borderwidth 2 -height 75 -relief groove \
        -width 125 
    label $base.fra31.01 \
        -background #8caad8 -borderwidth 1 -font {Helvetica -12} \
        -text {PaGEN Page Editor} 
    frame $base.fra33 \
        -background #8caad8 -borderwidth 2 -height 75 -relief groove \
        -width 125 
    listbox $base.fra33.lis35 \
        -yscrollcommand {.top29.fra33.scr38 set} 
    button $base.fra33.but36 \
        -background #ececec -command {Window hide .top29} \
        -highlightbackground #8caad8 -text Done 
    scrollbar $base.fra33.scr38 \
        -activebackground grey77 -activerelief sunken -background grey77 \
        -command {.top29.fra33.lis35 yview} 
    label $base.fra33.lab39 \
        -anchor w -background #8caad8 -borderwidth 1 -font {Helvetica -12} \
        -justify left -text {Select a page to edit} 
    button $base.fra33.but40 \
        -background #ececec \
        -command {if { [.top29.fra33.lis35 curselection ] != "" } {

  Pedit_page

}} \
        -highlightbackground #8caad8 -text {Edit selected} 
    menu $base.m37 \
        -cursor {} -tearoff 0 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.fra31 \
        -x 5 -y 5 -width 445 -height 30 -anchor nw -bordermode ignore 
    place $base.fra31.01 \
        -x 280 -y 5 -width 161 -height 18 -anchor nw -bordermode ignore 
    place $base.fra33 \
        -x 5 -y 40 -width 445 -height 190 -anchor nw -bordermode ignore 
    place $base.fra33.lis35 \
        -x 10 -y 25 -width 323 -height 126 -anchor nw -bordermode ignore 
    place $base.fra33.but36 \
        -x 385 -y 160 -anchor nw -bordermode ignore 
    place $base.fra33.scr38 \
        -x 335 -y 25 -width 21 -height 127 -anchor nw -bordermode ignore 
    place $base.fra33.lab39 \
        -x 5 -y 5 -width 296 -height 18 -anchor nw -bordermode ignore 
    place $base.fra33.but40 \
        -x 10 -y 155 -width 149 -height 26 -anchor nw -bordermode ignore 
}

proc vTclWindow.top41 {base} {
    if {$base == ""} {
        set base .top41
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel  -background #12bcca 
    wm focusmodel $base passive
    wm geometry $base 568x485+482+275
    wm maxsize $base 2545 930
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Page Editor"
    frame $base.fra42  -background #8caad8 -borderwidth 2 -height 75 -relief groove  -width 125 
    label $base.fra42.01  -background #8caad8 -borderwidth 1 -font {Helvetica -12}  -text {PaGEN Page Editor} 
    frame $base.fra44  -background #8caad8 -borderwidth 2 -height 75 -relief groove  -width 125 
    label $base.fra44.lab46  -anchor e -background #8caad8 -borderwidth 1 -font {Helvetica -12}  -text {Page ID} 
    label $base.fra44.lab47  -anchor e -background #8caad8 -borderwidth 1 -font {Helvetica -12}  -text Name 
    label $base.fra44.lab48  -anchor e -background #8caad8 -borderwidth 1 -font {Helvetica -12}  -text {Parent Page} 
    label $base.fra44.lab49  -anchor e -background #8caad8 -borderwidth 1 -font {Helvetica -12}  -text Category 
    label $base.fra44.lab50  -anchor e -background #8caad8 -borderwidth 1 -font {Helvetica -12}  -text Title 
    entry $base.fra44.ent51  -textvariable Apage(0,title) 
    label $base.fra44.lab52  -anchor e -background #8caad8 -borderwidth 1 -font {Helvetica -12}  -text {Icon File Name} 
    entry $base.fra44.ent53  -textvariable Apage(0,icon) 
    checkbutton $base.fra44.che54  -background #8caad8 -highlightbackground #8caad8 -text Render  -variable Apage(0,render) 
    entry $base.fra44.ent55  -textvariable Apage(0,file) 
    label $base.fra44.lab56  -anchor e -background #8caad8 -borderwidth 1 -font {Helvetica -12}  -text {HTML file name} 
    entry $base.fra44.ent57  -textvariable Apage(0,name) 
    entry $base.fra44.ent58  -state disabled -textvariable Apage(0,id) 
    menubutton $base.fra44.men60  -menu .top41.fra44.men60.01 -padx 4 -pady 3 -relief raised  -text index -textvariable Apage(0,parent) 
    menu $base.fra44.men60.01  -cursor {} -tearoff 0 
    menubutton $base.fra44.men61  -menu .top41.fra44.men61.01 -padx 4 -pady 3 -relief raised  -text correo -textvariable Apage(0,category) 
    menu $base.fra44.men61.01  -cursor {} -tearoff 0 
    button $base.fra44.but62  -command Psave_page -text {Save Changes} 
    button $base.fra44.but63  -command {Window hide .top41} -text {Discard Changes} 
    entry $base.fra44.ent64  -state disabled -textvariable Apage(0,parent_title) 
    frame $base.fra17  -background #8caad8 -borderwidth 2 -height 75 -relief groove  -width 125 
    label $base.fra17.01  -background #8caad8 -borderwidth 1 -font {Helvetica -12}  -text {Content of this page} 
    listbox $base.fra17.lis18  -yscrollcommand {.top41.fra17.scr19 set} 
    scrollbar $base.fra17.scr19  -background grey77 -command {.top41.fra17.lis18 yview} 
    button $base.fra17.but20   -command {Pedit_content [ .top41.fra17.lis18 get [ .top41.fra17.lis18 curselection ]]}  -font {Helvetica -11 bold} -text {Edit Selected} 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.fra42  -x 5 -y 5 -width 560 -height 30 -anchor nw -bordermode ignore 
    place $base.fra42.01  -x 395 -y 5 -width 161 -height 18 -anchor nw -bordermode ignore 
    place $base.fra44  -x 5 -y 35 -width 560 -height 300 -anchor nw -bordermode ignore 
    place $base.fra44.lab46  -x 135 -y 20 -width 121 -height 18 -anchor e -bordermode ignore 
    place $base.fra44.lab47  -x 135 -y 50 -width 121 -height 18 -anchor e -bordermode ignore 
    place $base.fra44.lab48  -x 135 -y 80 -width 121 -height 18 -anchor e -bordermode ignore 
    place $base.fra44.lab49  -x 135 -y 115 -width 121 -height 18 -anchor e -bordermode ignore 
    place $base.fra44.lab50  -x 135 -y 145 -width 121 -height 18 -anchor e -bordermode ignore 
    place $base.fra44.ent51  -x 150 -y 130 -width 398 -height 27 -anchor nw -bordermode ignore 
    place $base.fra44.lab52  -x 135 -y 175 -width 121 -height 18 -anchor e -bordermode ignore 
    place $base.fra44.ent53  -x 150 -y 160 -width 398 -height 27 -anchor nw -bordermode ignore 
    place $base.fra44.che54  -x 150 -y 230 -anchor nw -bordermode ignore 
    place $base.fra44.ent55  -x 150 -y 190 -width 398 -height 27 -anchor nw -bordermode ignore 
    place $base.fra44.lab56  -x 135 -y 205 -width 121 -height 18 -anchor e -bordermode ignore 
    place $base.fra44.ent57  -x 150 -y 35 -width 398 -height 27 -anchor nw -bordermode ignore 
    place $base.fra44.ent58  -x 150 -y 5 -width 158 -height 27 -anchor nw -bordermode ignore 
    place $base.fra44.men60  -x 150 -y 70 -width 104 -height 24 -anchor nw -bordermode ignore 
    place $base.fra44.men61  -x 150 -y 100 -width 104 -height 24 -anchor nw -bordermode ignore 
    place $base.fra44.but62  -x 390 -y 265 -width 157 -height 26 -anchor nw -bordermode ignore 
    place $base.fra44.but63  -x 10 -y 265 -width 157 -height 26 -anchor nw -bordermode ignore 
    place $base.fra44.ent64  -x 260 -y 70 -width 288 -height 22 -anchor nw -bordermode ignore 
    place $base.fra17  -x 5 -y 335 -width 560 -height 145 -anchor nw -bordermode ignore 
    place $base.fra17.01  -x 5 -y 10 -width 131 -height 18 -anchor nw -bordermode ignore 
    place $base.fra17.lis18  -x 135 -y 10 -width 303 -height 116 -anchor nw -bordermode ignore 
    place $base.fra17.scr19  -x 440 -y 10 -width 21 -height 117 -anchor nw -bordermode ignore 
    place $base.fra17.but20  -x 470 -y 10 -width 82 -height 26 -anchor nw -bordermode ignore
}

Window show .
Window show .top17

main $argc $argv
