--# PaGen : Page Generator

--# Author : Luis Miguel Arteaga Mejia
--#		(larteaga@yahoo.com)
--# Description: SQL Creation script of the needed tables. 
--# Version :   0.0.1 20.12.2001 LMA Original version
--#             0.1.0 04.02.2002 LMA Updated with the last changes done directly to the database. 
--#		0.1.1 05.02.2002 LMA Insert an initial control date.

--# Automated sequence.   
CREATE SEQUENCE "content_seq" start 1 increment 1 maxvalue 2147483647 minvalue 1  cache 1 ;

--# Categories core.

CREATE TABLE "categories" (
        "category" text NOT NULL,
        "directory" text
);

--# Content   

CREATE TABLE "content" (
        "id" int4 NOT NULL,
        "page" text NOT NULL,
        "title" text NOT NULL,
        "icon" text,
        "author" text,
        "date" text,
        "content" text,
        "last_modified" character(14),
        "split_level" int4,
        "priority" int4
);
CREATE TABLE "extra_content" (
        "id" int4 NOT NULL,
        "id_child" int4 NOT NULL
);
CREATE TABLE "child_contents" (
        "id_child" int4 NOT NULL,
        "content" text
);

--# Main pages table creation

CREATE TABLE "pages" (
        "id" int4 NOT NULL,
        "name" text NOT NULL,
        "parent" text,
        "category" text,
        "title" text,
        "icon" text,
        "file" text,
        "last_modified" character(14),
        "render" character(5)
);

--# View v_pages

CREATE TABLE "v_pages" (
        "id" int4,
        "name" text,
        "parent" text,
        "category" text,
        "title" text,
        "icon" text,
        "file" text,
        "last_modified" character(14),
        "directory" text
);
CREATE TABLE "control" (
        "last_run" character(14)
);
--# Create initial control date. 
insert into control values ('0');

CREATE RULE "_RETv_pages" AS ON SELECT TO v_pages DO INSTEAD 
	SELECT p.id, p.name, p.parent, p.category, p.title, p.icon, p.file, p.last_modified, c.directory 
	FROM pages p, categories c 
	WHERE (p.category = c.category);
